package com.muyu.compile;


import com.muyu.common.core.domain.Result;
import org.apache.catalina.startup.EngineConfig;

import javax.tools.*;
import java.io.File;
import java.io.IOException;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * @Author：蓬叁
 * @Package：com.muyu.compile
 * @Project：cloud-rule
 * @name：OSSFileCompile
 * @Date：2024/8/31 下午7:08
 */
public class OSSFileCompile{

//    public static Map<String, byte[]> compile(String fileName, String source,String extLib) throws IOException {
//        System.out.println("-------");
//        JavaCompiler compiler = ToolProvider.getSystemJavaCompiler();
//        StandardJavaFileManager stdManager = compiler.getStandardFileManager(null, null, null);
//        try (MemoryJavaFileManager manager = new MemoryJavaFileManager(stdManager)) {
//            JavaFileObject javaFileObject = manager.makeStringSource(fileName, source);
//            // 传入诊断监听器 size和传入的javaObject相同
//            DiagnosticCollector diagnosticCollector = new DiagnosticCollector();
//            List<String> optionList = Arrays.asList("-extdirs",extLib);
//            JavaCompiler.CompilationTask task = compiler.getTask(null, manager,diagnosticCollector, optionList, null, Arrays.asList(javaFileObject));
//            Boolean result = task.call();
//            if (result == null || !result.booleanValue()) {
//                throw new RuntimeException("Compilation failed.");
//            }
//            return manager.getClassBytes();
//        }
//    }

    public static Result<Object> compile(String source,String extLib){
        JavaCompiler compiler = ToolProvider.getSystemJavaCompiler();

        // 执行编译任务
        int result = compiler.run(null, null, null, source);

        // 检查编译结果
        if (result == 0) {
            System.out.println("编译成功，生成的.class文件位于源代码同目录");
            return Result.success("编译成功，生成的.class文件位于源代码同目录");
        } else {
            System.out.println("编译失败");
            return Result.error("编译失败");
        }
    }

}
